<template>
  <el-container>
    <el-main>
      <el-row type="flex" justify="center" class="mydiv">
        <el-col :span="12">
          <el-steps
            :active="stepActive"
            finish-status="success"
            align-center
          >
            <el-step title="用户认证"></el-step>
            <el-step title="身份确认"></el-step>
            <el-step title="密码重置"></el-step>
          </el-steps>
        </el-col>
      </el-row>

      <el-row type="flex" justify="center">
        <el-col :span="12">
          <el-divider></el-divider>
        </el-col>
      </el-row>

      <el-row type="flex" justify="center">
        <el-col :span="12">
          <el-form label-width="100px" :rules="rules">
            <el-form-item style="width: 100%">
              <el-alert style="height: 30px" type="error" v-if="tag1Error">{{
                tag1Info
              }}</el-alert>
            </el-form-item>
            <div v-show="stepActive === 0" style="width: 100%">
              <el-form-item label="用户名" :span="24">
                <el-input v-model="username" placeholder="请输入内容"></el-input>
              </el-form-item>
            </div>
            <div v-show="stepActive === 1" style="width: 100%">
              <el-form-item label="联系方式" :span="24">
                <el-input
                  v-model="connection"
                  @input="checkConnect"
                  @blur="checkConnect"
                  placeholder="请输入内容"
                ></el-input>
              </el-form-item>
              <el-form-item label="验证码" :span="24">
                <el-input
                  v-model="code"
                  style="width: 77%"
                  placeholder="请输入内容"
                ></el-input>
                <el-button
                  style="width: 21%"
                  @click="getCode"
                  :disabled="Disable"
                  >{{ count }}</el-button
                >
              </el-form-item>
            </div>
            <div v-show="stepActive === 2" style="width: 100%">
              <el-form-item label="密码" :span="24">
                <el-input v-model="password" placeholder="请输入内容"></el-input>
                <p></p>
              </el-form-item>
            </div>
          </el-form>
        </el-col>
      </el-row>

      <el-row type="flex" justify="center">
        <el-col style="text-align: center">
          <el-button @click="forgetpasswdnext">
            提交
          </el-button>
        </el-col>
      </el-row>
    </el-main>
  </el-container>
</template>

<script>
import forgetPassword from '@/services/forgetPassword'
export default {
  name: 'forgetpassword',
  data () {
    return {
      type: 0,
      Disable: true,
      username: '',
      connection: '',
      code: '',
      stepActive: 0,
      password: '1234567',
      tag1Error: false,
      tag1Info: '错误信息',
      count: '获取验证码',
      timer: null,
      cnt: 0,
      once: 0,
      rules: {
        username: [
          { required: true, message: '请输入用户名', trigger: 'blur' },
          {
            min: 3,
            max: 15,
            message: '长度在 3 到 15 个字符',
            trigger: 'blur'
          }
        ],
        password: [
          { required: true, message: '请输入密码', trigger: 'change' }
        ],
        connection: [
          {
            required: true,
            trigger: ['blur', 'change']
          }
        ]
      }
    }
  },
  methods: {
    async forgetpasswdnext () {
      console.log('post')
      this.tag1Error = false
      if (this.stepActive === 0) {
        if (this.username === '') {
          this.tag1Error = true
          this.tag1Info = '用户名不能为空'
          return
        }
      }
      if (this.stepActive === 1) {
        if (this.code === '') {
          this.tag1Error = true
          this.tag1Info = '验证码不能为空'
          return
        }
        if (this.connection === '') {
          this.tag1Error = true
          this.tag1Info = '联系方式不能为空'
          return
        }
        try {
          const response = await forgetPassword.forget({
            userName: this.username,
            connection: this.connection,
            type: this.type,
            code: this.code,
            status: '2'
          })
          console.log(response.data.code, response.data.msg)
          if (response.data.code !== 200) {
            this.tag1Error = true
            this.tag1Info = response.data.msg
            return
          }
        } catch (error) {
          if (
            error.response === undefined ||
            typeof error.response.data === 'undefined' ||
            error.response.data === undefined
          ) {
            this.tag1Error = true
            this.tag1Info = '网络错误,无法访问'
          } else {
            this.tag1Error = true
            this.tag1Info = error.response.data.msg
          }
        }
      }
      if (this.stepActive === 2) {
        if (this.password === '') {
          this.tag1Error = true
          this.tag1Info = '密码不能为空'
          return
        }
        try {
          const response = await forgetPassword.forget({
            userName: this.username,
            password: this.password,
            connection: this.connection,
            code: this.code,
            status: '3'
          })
          console.log(response.data.code, response.data.msg)
          if (response.data === undefined || response.data.code !== 200) {
            this.tag1Error = true
            this.tag1Info = response.data.msg
            return
          } else {
            this.$router.push('/login')
          }
        } catch (error) {
          if (
            error.response === undefined ||
            typeof error.response.data === 'undefined' ||
            error.response.data === undefined
          ) {
            this.tag1Error = true
            this.tag1Info = '网络错误,无法访问'
          } else {
            this.tag1Error = true
            this.tag1Info = error.response.data.msg
          }
        }
      }
      if (!this.tag1Error) {
        this.stepActive++
      }
    },
    async getCode () {
      this.Disable = true
      console.log('click')
      this.tag1Error = false
      if (this.connection === '') {
        this.tag1Error = true
        this.tag1Info = '联系方式不能为空'
        return
      }
      if (this.type === 0) {
        this.tag1Error = true
        this.tag1Info = '正确的联系方式格式错误'
      }
      this.once = 1
      if (this.stepActive === 1) {
        try {
          console.log(this.connection, this.type)
          const response = await forgetPassword.forget({
            userName: this.username,
            connection: this.connection,
            type: this.type,
            status: '1'
          })
          console.log(response.data.code, response.data.msg)
          if (response.data.code !== 200) {
            this.tag1Error = true
            this.tag1Info = response.data.msg
            this.Disable = false
            this.once = 0
            return
          }
          const TIME_COUNT = 60
          if (!this.timer) {
            this.cnt = TIME_COUNT
            this.Disable = true
            this.timer = setInterval(() => {
              if (this.cnt > 0 && this.cnt <= TIME_COUNT) {
                this.cnt--
                this.count = this.cnt + 'S'
              } else {
                if (this.type !== 0) {
                  this.Disable = true
                }
                clearInterval(this.timer) // 清除定时器
                this.timer = null
                this.count = '获取验证码'
                this.Disable = false
                this.once = 0
              }
            }, 1000)
          }
        } catch (error) {
          if (this.type !== 0) {
            this.Disable = false
          }
          this.once = 0
          if (
            error.response === undefined ||
            typeof error.response.data === 'undefined' ||
            error.response.data === undefined
          ) {
            this.tag1Error = true
            this.tag1Info = '网络错误,无法访问'
          } else {
            this.tag1Error = true
            this.tag1Info = error.response.data.msg
          }
        }
      } else {
        this.Disable = false
      }
    },
    checkConnect () {
      console.log(this.connection)
      this.type = 0
      if (!this.connection) {
        this.Disable = true
        return
      }
      let isTel = /^[a-z,A-Z,0-9]+@[a-z,A-Z]+.[a-z,A-Z]+$/.test(
        this.connection
      )
      let isMobile = /^1[345789]\d{9}$/.test(this.connection)
      if (isTel) this.type = 1
      else if (isMobile) this.type = 2
      if ((isTel || isMobile) && this.once === 0) {
        this.Disable = false
      } else if (!isTel && !isMobile) {
        this.Disable = true
      }
      console.log(this.type)
    }
  }
}
</script>

<style scoped>
  .mydiv{
     margin-top: 10%
  }
  .el-form{
    width: 78%;
    margin-left:7%;
  }
</style>
